
struct s_text {
	struct s_text *next;
	char *text;
	int xpos, ypos;
};

struct s_object {
	struct s_object *defnext, *tblnext;
	char *label;
	char *name;
	int xpos, width, id, newlyborn;
	int state, depth;
};

#define OBJSTATE_UNDEF 0
#define OBJSTATE_INACTIVE 1
#define OBJSTATE_ACTIVE 2
#define OBJSTATE_UNBORN 3
#define OBJSTATE_BEINGBORN1 4
#define OBJSTATE_BEINGBORN2 5

struct s_message {
	struct s_object *obj;
	char *msg;
	int creation;
};

struct s_action {
	struct s_action *next;
	struct s_message *msg;	/* can be null, meaning nop */
	struct s_action *whathappen;
	char *retval;
	int deletion;
};

struct s_diagram {
	struct s_object *objects;
	struct s_action *seq;
	struct s_text *texts;
};

	
